/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the GatewayContextualHelp type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GatewayContextualHelp{}

// GatewayContextualHelp struct for GatewayContextualHelp
type GatewayContextualHelp struct {
	Var360Status *string `json:"360_status,omitempty"`
	Var360ClientId *string `json:"360_client_id,omitempty"`
	Var360ExternalId *string `json:"360_external_id,omitempty"`
	Var360Namespace *string `json:"360_namespace,omitempty"`
	Maid *string `json:"maid,omitempty"`
	Name *string `json:"name,omitempty"`
	Email *string `json:"email,omitempty"`
}

// NewGatewayContextualHelp instantiates a new GatewayContextualHelp object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGatewayContextualHelp() *GatewayContextualHelp {
	this := GatewayContextualHelp{}
	var var360Status string = "new_client"
	this.Var360Status = &var360Status
	return &this
}

// NewGatewayContextualHelpWithDefaults instantiates a new GatewayContextualHelp object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGatewayContextualHelpWithDefaults() *GatewayContextualHelp {
	this := GatewayContextualHelp{}
	var var360Status string = "new_client"
	this.Var360Status = &var360Status
	return &this
}

// GetVar360Status returns the Var360Status field value if set, zero value otherwise.
func (o *GatewayContextualHelp) GetVar360Status() string {
	if o == nil || IsNil(o.Var360Status) {
		var ret string
		return ret
	}
	return *o.Var360Status
}

// GetVar360StatusOk returns a tuple with the Var360Status field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GatewayContextualHelp) GetVar360StatusOk() (*string, bool) {
	if o == nil || IsNil(o.Var360Status) {
		return nil, false
	}
	return o.Var360Status, true
}

// HasVar360Status returns a boolean if a field has been set.
func (o *GatewayContextualHelp) HasVar360Status() bool {
	if o != nil && !IsNil(o.Var360Status) {
		return true
	}

	return false
}

// SetVar360Status gets a reference to the given string and assigns it to the Var360Status field.
func (o *GatewayContextualHelp) SetVar360Status(v string) {
	o.Var360Status = &v
}

// GetVar360ClientId returns the Var360ClientId field value if set, zero value otherwise.
func (o *GatewayContextualHelp) GetVar360ClientId() string {
	if o == nil || IsNil(o.Var360ClientId) {
		var ret string
		return ret
	}
	return *o.Var360ClientId
}

// GetVar360ClientIdOk returns a tuple with the Var360ClientId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GatewayContextualHelp) GetVar360ClientIdOk() (*string, bool) {
	if o == nil || IsNil(o.Var360ClientId) {
		return nil, false
	}
	return o.Var360ClientId, true
}

// HasVar360ClientId returns a boolean if a field has been set.
func (o *GatewayContextualHelp) HasVar360ClientId() bool {
	if o != nil && !IsNil(o.Var360ClientId) {
		return true
	}

	return false
}

// SetVar360ClientId gets a reference to the given string and assigns it to the Var360ClientId field.
func (o *GatewayContextualHelp) SetVar360ClientId(v string) {
	o.Var360ClientId = &v
}

// GetVar360ExternalId returns the Var360ExternalId field value if set, zero value otherwise.
func (o *GatewayContextualHelp) GetVar360ExternalId() string {
	if o == nil || IsNil(o.Var360ExternalId) {
		var ret string
		return ret
	}
	return *o.Var360ExternalId
}

// GetVar360ExternalIdOk returns a tuple with the Var360ExternalId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GatewayContextualHelp) GetVar360ExternalIdOk() (*string, bool) {
	if o == nil || IsNil(o.Var360ExternalId) {
		return nil, false
	}
	return o.Var360ExternalId, true
}

// HasVar360ExternalId returns a boolean if a field has been set.
func (o *GatewayContextualHelp) HasVar360ExternalId() bool {
	if o != nil && !IsNil(o.Var360ExternalId) {
		return true
	}

	return false
}

// SetVar360ExternalId gets a reference to the given string and assigns it to the Var360ExternalId field.
func (o *GatewayContextualHelp) SetVar360ExternalId(v string) {
	o.Var360ExternalId = &v
}

// GetVar360Namespace returns the Var360Namespace field value if set, zero value otherwise.
func (o *GatewayContextualHelp) GetVar360Namespace() string {
	if o == nil || IsNil(o.Var360Namespace) {
		var ret string
		return ret
	}
	return *o.Var360Namespace
}

// GetVar360NamespaceOk returns a tuple with the Var360Namespace field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GatewayContextualHelp) GetVar360NamespaceOk() (*string, bool) {
	if o == nil || IsNil(o.Var360Namespace) {
		return nil, false
	}
	return o.Var360Namespace, true
}

// HasVar360Namespace returns a boolean if a field has been set.
func (o *GatewayContextualHelp) HasVar360Namespace() bool {
	if o != nil && !IsNil(o.Var360Namespace) {
		return true
	}

	return false
}

// SetVar360Namespace gets a reference to the given string and assigns it to the Var360Namespace field.
func (o *GatewayContextualHelp) SetVar360Namespace(v string) {
	o.Var360Namespace = &v
}

// GetMaid returns the Maid field value if set, zero value otherwise.
func (o *GatewayContextualHelp) GetMaid() string {
	if o == nil || IsNil(o.Maid) {
		var ret string
		return ret
	}
	return *o.Maid
}

// GetMaidOk returns a tuple with the Maid field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GatewayContextualHelp) GetMaidOk() (*string, bool) {
	if o == nil || IsNil(o.Maid) {
		return nil, false
	}
	return o.Maid, true
}

// HasMaid returns a boolean if a field has been set.
func (o *GatewayContextualHelp) HasMaid() bool {
	if o != nil && !IsNil(o.Maid) {
		return true
	}

	return false
}

// SetMaid gets a reference to the given string and assigns it to the Maid field.
func (o *GatewayContextualHelp) SetMaid(v string) {
	o.Maid = &v
}

// GetName returns the Name field value if set, zero value otherwise.
func (o *GatewayContextualHelp) GetName() string {
	if o == nil || IsNil(o.Name) {
		var ret string
		return ret
	}
	return *o.Name
}

// GetNameOk returns a tuple with the Name field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GatewayContextualHelp) GetNameOk() (*string, bool) {
	if o == nil || IsNil(o.Name) {
		return nil, false
	}
	return o.Name, true
}

// HasName returns a boolean if a field has been set.
func (o *GatewayContextualHelp) HasName() bool {
	if o != nil && !IsNil(o.Name) {
		return true
	}

	return false
}

// SetName gets a reference to the given string and assigns it to the Name field.
func (o *GatewayContextualHelp) SetName(v string) {
	o.Name = &v
}

// GetEmail returns the Email field value if set, zero value otherwise.
func (o *GatewayContextualHelp) GetEmail() string {
	if o == nil || IsNil(o.Email) {
		var ret string
		return ret
	}
	return *o.Email
}

// GetEmailOk returns a tuple with the Email field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GatewayContextualHelp) GetEmailOk() (*string, bool) {
	if o == nil || IsNil(o.Email) {
		return nil, false
	}
	return o.Email, true
}

// HasEmail returns a boolean if a field has been set.
func (o *GatewayContextualHelp) HasEmail() bool {
	if o != nil && !IsNil(o.Email) {
		return true
	}

	return false
}

// SetEmail gets a reference to the given string and assigns it to the Email field.
func (o *GatewayContextualHelp) SetEmail(v string) {
	o.Email = &v
}

func (o GatewayContextualHelp) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GatewayContextualHelp) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Var360Status) {
		toSerialize["360_status"] = o.Var360Status
	}
	if !IsNil(o.Var360ClientId) {
		toSerialize["360_client_id"] = o.Var360ClientId
	}
	if !IsNil(o.Var360ExternalId) {
		toSerialize["360_external_id"] = o.Var360ExternalId
	}
	if !IsNil(o.Var360Namespace) {
		toSerialize["360_namespace"] = o.Var360Namespace
	}
	if !IsNil(o.Maid) {
		toSerialize["maid"] = o.Maid
	}
	if !IsNil(o.Name) {
		toSerialize["name"] = o.Name
	}
	if !IsNil(o.Email) {
		toSerialize["email"] = o.Email
	}
	return toSerialize, nil
}

type NullableGatewayContextualHelp struct {
	value *GatewayContextualHelp
	isSet bool
}

func (v NullableGatewayContextualHelp) Get() *GatewayContextualHelp {
	return v.value
}

func (v *NullableGatewayContextualHelp) Set(val *GatewayContextualHelp) {
	v.value = val
	v.isSet = true
}

func (v NullableGatewayContextualHelp) IsSet() bool {
	return v.isSet
}

func (v *NullableGatewayContextualHelp) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGatewayContextualHelp(val *GatewayContextualHelp) *NullableGatewayContextualHelp {
	return &NullableGatewayContextualHelp{value: val, isSet: true}
}

func (v NullableGatewayContextualHelp) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGatewayContextualHelp) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


